import { Camera } from '@tresjs/core';
import { Scene } from 'three';
export interface EffectComposerProps {
    /**
     * Whether the effect composer is enabled.
     * @default true
     * @type {boolean}
     * @memberof EffectComposerProps
     * @name enabled
     *
     **/
    enabled?: boolean;
    /**
     * The children of the effect composer.
     * @default []
     * @type {Array}
     * @memberof EffectComposerProps
     * @name children
     *
     **/
    children?: Array<any>;
    /**
     * Whether the depth buffer is enabled.
     * @default true
     * @type {boolean}
     * @memberof EffectComposerProps
     * @name depthBuffer
     *
     **/
    depthBuffer?: boolean;
    /**
     *
     * @default false
     * @type {boolean}
     * @memberof EffectComposerProps
     * @name dissableNormalPass
     *
     **/
    dissableNormalPass?: boolean;
    /**
     *
     * Stencil buffer.
     *
     * @type {boolean}
     * @memberof EffectComposerProps
     * @name stencilBuffer
     *
     **/
    stencilBuffer?: boolean;
    /**
     *
     * Whether the effect composer should clear the buffers before rendering.
     *
     * @type {boolean}
     * @memberof EffectComposerProps
     * @name autoClear
     *
     **/
    autoClear?: boolean;
    /**
     *
     * The resolution scale.
     *
     * @type {number}
     * @memberof EffectComposerProps
     * @name resolutionScale
     *
     **/
    resolutionScale?: number;
    /**
     *
     * The multisampling.
     *
     * @type {number}
     * @memberof EffectComposerProps
     * @name multisampling
     *
     **/
    multisampling?: number;
    /**
     *
     * The frame buffer type.
     *
     * @type {number}
     * @memberof EffectComposerProps
     * @name frameBufferType
     *
     **/
    frameBufferType?: number;
    /**
     *
     * The render priority.
     *
     * @type {number}
     * @memberof EffectComposerProps
     * @name renderPriority
     *
     **/
    renderPriority?: number;
    /**
     *
     * A camera to use for rendering.
     *
     * @type {Camera}
     * @memberof EffectComposerProps
     * @name camera
     *
     **/
    camera?: Camera;
    /**
     * A scene to use for rendering.
     * @type {Scene}
     * @memberof EffectComposerProps
     * @name scene
     *
     **/
    scene?: Scene;
}
export declare const EffectComposer: import("vue").DefineComponent<EffectComposerProps, {}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<EffectComposerProps>, {}>;
