/**
 * name: @tresjs/post-processing
 * version: v0.1.0
 * (c) 2023
 * description: Post-processing library for Tres
 * author: Alvaro Saburido <hola@alvarosaburido.dev> (https://github.com/alvarosabu/)
 */
import { getCurrentInstance as L, onMounted as S, nextTick as H, getCurrentScope as N, onScopeDispose as O, unref as P, toRef as I, readonly as k, customRef as Q, ref as v, watch as y, watchEffect as b, computed as j, inject as w, defineComponent as g, toRefs as F, shallowRef as V, provide as _, toRaw as M } from "vue";
import { useTres as $, useRenderLoop as q } from "@tresjs/core";
import { HalfFloatType as J } from "three";
import { EffectComposer as K, RenderPass as U, NormalPass as X, DepthDownsamplingPass as Y, EffectPass as R, BloomEffect as Z, GlitchEffect as ee } from "postprocessing";
function x(e) {
  return N() ? (O(e), !0) : !1;
}
function A(e) {
  return typeof e == "function" ? e() : P(e);
}
const te = typeof window < "u", B = () => {
};
function ne(...e) {
  if (e.length !== 1)
    return I(...e);
  const t = e[0];
  return typeof t == "function" ? k(Q(() => ({ get: t, set: B }))) : v(t);
}
function ae(e, t = !0) {
  L() ? S(e) : t ? e() : H(e);
}
function re(e) {
  var t;
  const n = A(e);
  return (t = n == null ? void 0 : n.$el) != null ? t : n;
}
const E = te ? window : void 0;
function oe(...e) {
  let t, n, r, a;
  if (typeof e[0] == "string" || Array.isArray(e[0]) ? ([n, r, a] = e, t = E) : [t, n, r, a] = e, !t)
    return B;
  Array.isArray(n) || (n = [n]), Array.isArray(r) || (r = [r]);
  const o = [], l = () => {
    o.forEach((c) => c()), o.length = 0;
  }, s = (c, m, d, f) => (c.addEventListener(m, d, f), () => c.removeEventListener(m, d, f)), u = y(
    () => [re(t), A(a)],
    ([c, m]) => {
      l(), c && o.push(
        ...n.flatMap((d) => r.map((f) => s(c, d, f, m)))
      );
    },
    { immediate: !0, flush: "post" }
  ), i = () => {
    u(), l();
  };
  return x(i), i;
}
function ie() {
  const e = v(!1);
  return L() && S(() => {
    e.value = !0;
  }), e;
}
function se(e) {
  const t = ie();
  return j(() => (t.value, !!e()));
}
function ue(e, t = {}) {
  const { window: n = E } = t, r = se(() => n && "matchMedia" in n && typeof n.matchMedia == "function");
  let a;
  const o = v(!1), l = () => {
    a && ("removeEventListener" in a ? a.removeEventListener("change", s) : a.removeListener(s));
  }, s = () => {
    r.value && (l(), a = n.matchMedia(ne(e).value), o.value = !!(a != null && a.matches), a && ("addEventListener" in a ? a.addEventListener("change", s) : a.addListener(s)));
  };
  return b(s), x(() => l()), o;
}
function le(e = {}) {
  const {
    window: t = E,
    initialWidth: n = 1 / 0,
    initialHeight: r = 1 / 0,
    listenOrientation: a = !0,
    includeScrollbar: o = !0
  } = e, l = v(n), s = v(r), u = () => {
    t && (o ? (l.value = t.innerWidth, s.value = t.innerHeight) : (l.value = t.document.documentElement.clientWidth, s.value = t.document.documentElement.clientHeight));
  };
  if (u(), ae(u), oe("resize", u, { passive: !0 }), a) {
    const i = ue("(orientation: portrait)");
    y(i, () => u());
  }
  return { width: l, height: s };
}
let p;
function ce() {
  if (p !== void 0)
    return p;
  try {
    var e;
    let t;
    const n = document.createElement("canvas");
    return p = !!(window.WebGL2RenderingContext && (t = n.getContext("webgl2"))), t && ((e = t.getExtension("WEBGL_lose_context")) === null || e === void 0 || e.loseContext()), p;
  } catch {
    return p = !1;
  }
}
function C() {
  const { state: e, setState: t } = w("useTres", $()), n = w("extend") || (() => {
  });
  return {
    state: e,
    setState: t,
    extend: n
  };
}
const pe = g({
  name: "EffectComposer",
  props: [
    "enabled",
    "children",
    "depthBuffer",
    "dissableNormalPass",
    "stencilBuffer",
    "autoClear",
    "resolutionScale",
    "multisampling",
    "frameBufferType",
    "renderPriority",
    "camera",
    "scene"
  ],
  setup(e, { slots: t }) {
    const { state: n } = C(), {
      enabled: r = !0,
      renderPriority: a = 1,
      autoClear: o = !0,
      multisampling: l = 8,
      frameBufferType: s = J,
      resolutionScale: u
    } = F(e), i = V(null), c = e.scene || n.scene, m = e.camera || n.camera;
    let d = null, f = null;
    const W = ce();
    _("effectComposer", i);
    const { width: G, height: T } = le();
    function z() {
      i.value && (f = new X(c, m), f.enabled = !1, i.value.addPass(f), u.value !== void 0 && W && (d = new Y({
        normalBuffer: f.texture,
        resolutionScale: u == null ? void 0 : u.value
      }), d.enabled = !1, i.value.addPass(d)));
    }
    b(() => {
      n.renderer && n.scene && n.camera && (n.renderer.setSize(G.value, T.value), n.renderer.setPixelRatio(Math.min(window.devicePixelRatio, 2)), i.value = new K(n.renderer), i.value.addPass(new U(c, m)), e.dissableNormalPass || z());
    }), y(
      () => e.enabled,
      (h) => {
        i.value && (i.value.enabled = h);
      }
    );
    const { onLoop: D } = q();
    return D(() => {
      i.value && i.value.render();
    }), () => {
      var h;
      return (h = t.default) == null ? void 0 : h.call(t);
    };
  }
}), he = g({
  name: "Bloom",
  props: [
    "intensity",
    "blurPass",
    "width",
    "height",
    "kernelSize",
    "luminanceThreshold",
    "luminanceSmoothing"
  ],
  async setup(e, { expose: t }) {
    const { state: n } = C(), r = w("effectComposer"), a = v(null);
    return t({ getPass: () => a.value }), b(() => {
      var o;
      n.camera && r && r.value && (a.value = new R(P(n.camera), new Z(e)), (o = r == null ? void 0 : r.value) == null || o.addPass(M(a.value)));
    }), () => {
    };
  }
}), we = g({
  name: "Glitch",
  props: [
    "delay",
    "duration",
    "strength",
    "mode",
    "active",
    "ratio",
    "columns",
    "chromaticAberrationOffset",
    "peturbationMap",
    "dtSize"
  ],
  async setup(e, { expose: t }) {
    const { state: n } = C(), r = w("effectComposer"), a = v(null);
    return t({ getPass: () => a.value }), b(() => {
      var o;
      n.camera && r && r.value && (a.value = new R(P(n.camera), new ee(e)), (o = r == null ? void 0 : r.value) == null || o.addPass(M(a.value)));
    }), y(
      () => e.active,
      (o) => {
        a.value && (a.value.enabled = o);
      }
    ), () => {
    };
  }
});
export {
  he as Bloom,
  pe as EffectComposer,
  we as Glitch
};
